diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/ProviderInfo.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/ProviderInfo.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/ProviderInfo.java	2017-09-27 02:07:48.943736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/ProviderInfo.java	2017-08-22 12:32:43.782645000 +0900
@@ -70,7 +70,10 @@
      *  to run in different process.  If false, a single instances is always
      *  run in {@link #processName}. */
     public boolean multiprocess = false;
-    
+
+    //collaboroid
+    public boolean remoteable = false;
+
     /** Used to control initialization order of single-process providers
      *  running in the same process.  Higher goes first. */
     public int initOrder = 0;
@@ -109,6 +112,9 @@
         uriPermissionPatterns = orig.uriPermissionPatterns;
         pathPermissions = orig.pathPermissions;
         multiprocess = orig.multiprocess;
+        //collaboroid
+        remoteable = orig.remoteable;
+
         initOrder = orig.initOrder;
         flags = orig.flags;
         isSyncable = orig.isSyncable;
@@ -133,6 +139,9 @@
         out.writeTypedArray(uriPermissionPatterns, parcelableFlags);
         out.writeTypedArray(pathPermissions, parcelableFlags);
         out.writeInt(multiprocess ? 1 : 0);
+        //collaboroid
+        out.writeInt(remoteable ? 1 : 0);
+
         out.writeInt(initOrder);
         out.writeInt(flags);
         out.writeInt(isSyncable ? 1 : 0);
@@ -162,6 +171,9 @@
         uriPermissionPatterns = in.createTypedArray(PatternMatcher.CREATOR);
         pathPermissions = in.createTypedArray(PathPermission.CREATOR);
         multiprocess = in.readInt() != 0;
+        //collaboroid
+        remoteable = in.readInt() != 0;
+
         initOrder = in.readInt();
         flags = in.readInt();
         isSyncable = in.readInt() != 0;
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/ReverseLineInputStream.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/ReverseLineInputStream.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/pm/ReverseLineInputStream.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/pm/ReverseLineInputStream.java	2017-07-24 13:56:04.398019000 +0900
@@ -0,0 +1,130 @@
+package android.content.pm;
+
+/**
+ * Created by jake on 17. 3. 2.
+ */
+
+import java.io.File;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.RandomAccessFile;
+
+
+public class ReverseLineInputStream extends InputStream {
+
+    private static final int MAX_LINE_BYTES = 1024 * 1024;
+
+    private static final int DEFAULT_BUFFER_SIZE = 1024 * 1024;
+
+    private RandomAccessFile in;
+
+    private long currentFilePos;
+
+    private int bufferSize;
+    private byte[] buffer;
+    private int currentBufferPos;
+
+    private int maxLineBytes;
+    private byte[] currentLine;
+    private int currentLineWritePos = 0;
+    private int currentLineReadPos = 0;
+    private boolean lineBuffered = false;
+
+    public ReverseLineInputStream(File file) throws IOException {
+        this(file, DEFAULT_BUFFER_SIZE, MAX_LINE_BYTES);
+    }
+
+    public ReverseLineInputStream(File file, int bufferSize, int maxLineBytes) throws IOException {
+        this.maxLineBytes = maxLineBytes;
+        in = new RandomAccessFile(file, "r");
+        currentFilePos = file.length() - 1;
+        in.seek(currentFilePos);
+        if (in.readByte() == 0xA) {
+            currentFilePos--;
+        }
+        currentLine = new byte[maxLineBytes];
+        currentLine[0] = 0xA;
+
+        this.bufferSize = bufferSize;
+        buffer = new byte[bufferSize];
+        fillBuffer();
+        fillLineBuffer();
+    }
+
+    @Override
+    public int read() throws IOException {
+        if (currentFilePos <= 0 && currentBufferPos < 0 && currentLineReadPos < 0) {
+            return -1;
+        }
+
+        if (!lineBuffered) {
+            fillLineBuffer();
+        }
+
+
+        if (lineBuffered) {
+            if (currentLineReadPos == 0) {
+                lineBuffered = false;
+            }
+            return currentLine[currentLineReadPos--];
+        }
+        return 0;
+    }
+
+    private void fillBuffer() throws IOException {
+        if (currentFilePos < 0) {
+            return;
+        }
+
+        if (currentFilePos < bufferSize) {
+            in.seek(0);
+            in.read(buffer);
+            currentBufferPos = (int) currentFilePos;
+            currentFilePos = -1;
+        } else {
+            in.seek(currentFilePos);
+            in.read(buffer);
+            currentBufferPos = bufferSize - 1;
+            currentFilePos = currentFilePos - bufferSize;
+        }
+    }
+
+    private void fillLineBuffer() throws IOException {
+        currentLineWritePos = 1;
+        while (true) {
+
+            // we've read all the buffer - need to fill it again
+            if (currentBufferPos < 0) {
+                fillBuffer();
+
+                // nothing was buffered - we reached the beginning of a file
+                if (currentBufferPos < 0) {
+                    currentLineReadPos = currentLineWritePos - 1;
+                    lineBuffered = true;
+                    return;
+                }
+            }
+
+            byte b = buffer[currentBufferPos--];
+
+            // \n is found - line fully buffered
+            if (b == 0xA) {
+                currentLineReadPos = currentLineWritePos - 1;
+                lineBuffered = true;
+                break;
+
+                // just ignore \r for now
+            } else if (b == 0xD) {
+                continue;
+            } else {
+                if (currentLineWritePos == maxLineBytes) {
+                    throw new IOException("file has a line exceeding " + maxLineBytes
+                            + " bytes; use constructor to pickup bigger line buffer");
+                }
+
+                // write the current line bytes in reverse order - reading from
+                // the end will produce the correct line
+                currentLine[currentLineWritePos++] = b;
+            }
+        }
+    }}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/res/ABCManager.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/ABCManager.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/res/ABCManager.java	1970-01-01 09:00:00.000000000 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/ABCManager.java	2017-02-15 11:52:14.457103000 +0900
@@ -0,0 +1,205 @@
+/*
+ * Copyright (C) 2006 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package android.content.res;
+
+import android.os.ParcelFileDescriptor;
+import android.util.Log;
+import android.util.SparseArray;
+import android.util.TypedValue;
+
+import java.io.FileNotFoundException;
+import java.io.IOException;
+import java.io.InputStream;
+import java.util.HashMap;
+
+/**
+ * Provides access to an application's raw asset files; see {@link Resources}
+ * for the way most applications will want to retrieve their resource data.
+ * This class presents a lower-level API that allows you to open and read raw
+ * files that have been bundled with the application as a simple stream of
+ * bytes.
+ */
+public final class ABCManager extends AssetManager {
+    /* modes used when opening an asset */
+
+    /**
+     * Mode for {@link #open(String, int)}: no specific information about how
+     * data will be accessed.
+     */
+    public static final int ACCESS_UNKNOWN = 0;
+    /**
+     * Mode for {@link #open(String, int)}: Read chunks, and seek forward and
+     * backward.
+     */
+    public static final int ACCESS_RANDOM = 1;
+    /**
+     * Mode for {@link #open(String, int)}: Read sequentially, with an
+     * occasional forward seek.
+     */
+    public static final int ACCESS_STREAMING = 2;
+    /**
+     * Mode for {@link #open(String, int)}: Attempt to load contents into
+     * memory, for fast small reads.
+     */
+    public static final int ACCESS_BUFFER = 3;
+
+    private static final String TAG = "ABCManager";
+    private static final boolean localLOGV = false || false;
+    
+    private static final boolean DEBUG_REFS = false;
+    
+    private static final Object sSync = new Object();
+    /*package*/ static ABCManager sManager = null;
+
+    private final TypedValue mValue = new TypedValue();
+    private final long[] mOffsets = new long[2];
+    
+    // For communication with native code.
+    private long mObject;
+
+    private StringBlock mStringBlocks[] = null;
+    
+    private int mNumRefs = 1;
+    private boolean mOpen = true;
+    private HashMap<Long, RuntimeException> mRefStacks;
+    private HashMap<String, String> mKeyToPath;
+    private HashMap<String, Integer> mNameToId;
+    
+    //private native int aapt(String resPath, String manifestPath, String outputApk);
+ 
+    /**
+     * Create a new ABCManager containing only the basic system assets.
+     * Applications will not generally use this method, instead retrieving the
+     * appropriate asset manager with {@link Resources#getAssets}.    Not for
+     * use by applications.
+     * {@hide}
+     */
+    public ABCManager() 
+    {
+        if (DEBUG_REFS) {
+        	synchronized (this) {
+                mNumRefs = 0;
+                incRefsLocked(this.hashCode());
+            }
+        }
+        init(false);
+        mKeyToPath = new HashMap<String, String>();
+        mNameToId = new HashMap<String, Integer>();
+        if (localLOGV) Log.v(TAG, "New ABC manager: " + this);
+        //ensureManager();
+    }
+
+    private static void ensureManager() {
+        synchronized (sSync) {
+            if (sManager == null) {
+                ABCManager system = new ABCManager();
+                system.makeStringBlocks(null);
+                sManager = system;
+            }
+        }
+    }
+    
+    /*private ABCManager(boolean isSystem) {
+        if (DEBUG_REFS) {
+            synchronized (this) {
+                mNumRefs = 0;
+                incRefsLocked(this.hashCode());
+            }
+        }
+        init(true);
+        if (localLOGV) Log.v(TAG, "New asset manager: " + this);
+    }*/
+
+    /**
+     * Return a global shared asset manager that provides access to only
+     * system assets (no application assets).
+     * {@hide}
+     */
+    public static ABCManager getManager() {
+    	ensureManager();
+        return sManager;
+    }
+
+    /**
+     * Close this asset manager.
+     */
+    public void close() {
+        synchronized(this) {
+            //System.out.println("Release: num=" + mNumRefs
+            //                   + ", released=" + mReleased);
+            if (mOpen) {
+                mOpen = false;
+                decRefsLocked(this.hashCode());
+            }
+        }
+    }
+
+    public void addResource(int id)
+    {
+    	String entryName = getResourceEntryName(id);
+    	
+    	Log.d(TAG, entryName + " - " + id);
+    	
+    	if(entryName != null)
+    		mNameToId.put(entryName, id);
+    }
+    
+    public int getIdFromName(String name)
+    {
+
+    	if(mNameToId.containsKey(name)){
+            return mNameToId.get(name);
+        }
+    	else{
+            return -1;
+        }
+    }
+
+    public HashMap<String, String> getmKeyToPath(){
+        return this.mKeyToPath;
+    }
+    public HashMap<String, Integer> getmNameToId(){
+        return this.mNameToId;
+    }
+
+    private native final void init(boolean isSystem);
+    private native final void destroy();
+
+    private final void incRefsLocked(long id) {
+        if (DEBUG_REFS) {
+            if (mRefStacks == null) {
+                mRefStacks = new HashMap<Long, RuntimeException>();
+            }
+            RuntimeException ex = new RuntimeException();
+            ex.fillInStackTrace();
+            mRefStacks.put(id, ex);
+        }
+        mNumRefs++;
+    }
+    
+    private final void decRefsLocked(long id) {
+        if (DEBUG_REFS && mRefStacks != null) {
+            mRefStacks.remove(id);
+        }
+        mNumRefs--;
+        //System.out.println("Dec streams: mNumRefs=" + mNumRefs
+        //                   + " mReleased=" + mReleased);
+        if (mNumRefs == 0) {
+            destroy();
+        }
+    }
+}
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/res/AssetManager.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/AssetManager.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/res/AssetManager.java	2017-09-27 02:07:48.943736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/AssetManager.java	2017-07-13 14:14:41.760275000 +0900
@@ -33,7 +33,7 @@
  * files that have been bundled with the application as a simple stream of
  * bytes.
  */
-public final class AssetManager implements AutoCloseable {
+public class AssetManager implements AutoCloseable {
     /* modes used when opening an asset */
 
     /**
@@ -100,6 +100,7 @@
         synchronized (sSync) {
             if (sSystem == null) {
                 AssetManager system = new AssetManager(true);
+                //Log.d("reviseApp2","system.makeStringBlocks(null)");
                 system.makeStringBlocks(null);
                 sSystem = system;
             }
@@ -158,6 +159,30 @@
         }
         return null;
     }
+    public CharSequence getResourceText2(int ident) {
+        synchronized (this) {
+
+            //Log.d("reviseApp2","getResourceText2 ident : " + ident);
+            TypedValue tmpValue = mValue;
+            //Log.d("reviseApp2","getResourceText2 before tmpValue.data : " + tmpValue.data);
+            int block = loadResourceValue(ident, (short) 0, tmpValue, true);
+            //Log.d("reviseApp2","getResourceText2 block : " + block);
+            //1
+            //Log.d("reviseApp2","getResourceText2 after tmpValue.data : " + tmpValue.data);
+            //0
+
+            if (block >= 0) {
+                if (tmpValue.type == TypedValue.TYPE_STRING) {
+                    //Log.d("reviseApp2","getResourceText2  mStringBlocks[block] : " + mStringBlocks[block].get(tmpValue.data).toString());
+                    return mStringBlocks[block].get(tmpValue.data);
+
+                }
+                return tmpValue.coerceToString();
+            }
+        }
+        return null;
+    }
+
 
     /**
      * Retrieve the string value associated with a particular resource
@@ -193,12 +218,14 @@
                                                TypedValue outValue,
                                                boolean resolveRefs)
     {
+        //Log.d("reviseApp","getResourceStringArray ident : " + Integer.toHexString(ident));
         int block = loadResourceValue(ident, (short) density, outValue, resolveRefs);
         if (block >= 0) {
             if (outValue.type != TypedValue.TYPE_STRING) {
                 return true;
             }
             outValue.string = mStringBlocks[block].get(outValue.data);
+            //Log.d("reviseApp","getResourceStringArray : " + outValue.string);
             return true;
         }
         return false;
@@ -246,6 +273,7 @@
         if (mStringBlocks == null) {
             synchronized (this) {
                 if (mStringBlocks == null) {
+                    //Log.d("reviseApp2","makeStringBlocks : " + sSystem.mStringBlocks);
                     makeStringBlocks(sSystem.mStringBlocks);
                 }
             }
@@ -255,14 +283,19 @@
     /*package*/ final void makeStringBlocks(StringBlock[] seed) {
         final int seedNum = (seed != null) ? seed.length : 0;
         final int num = getStringBlockCount();
+        //Log.d("reviseApp2","getStringBlockCount : " + getStringBlockCount());
+        //2
         mStringBlocks = new StringBlock[num];
+
         if (localLOGV) Log.v(TAG, "Making string blocks for " + this
                 + ": " + num);
         for (int i=0; i<num; i++) {
             if (i < seedNum) {
                 mStringBlocks[i] = seed[i];
+                //Log.d("reviseApp2","seed[i] : " + mStringBlocks[i].get(0).toString());
             } else {
                 mStringBlocks[i] = new StringBlock(getNativeStringBlock(i), true);
+                //Log.d("reviseApp2","mStringBlocks[i] : " + mStringBlocks[i].get(0).toString());
             }
         }
     }
@@ -310,6 +343,9 @@
             if (!mOpen) {
                 throw new RuntimeException("Assetmanager has been closed");
             }
+            
+            Log.d(TAG, "ASSETMANAGER - " + fileName);
+            
             long asset = openAsset(fileName, accessMode);
             if (asset != 0) {
                 AssetInputStream res = new AssetInputStream(asset);
@@ -437,6 +473,7 @@
      * 
      * @param fileName The name of the file to retrieve.
      */
+    //ADDED COLLABOROID
     public final XmlResourceParser openXmlResourceParser(String fileName)
             throws IOException {
         return openXmlResourceParser(0, fileName);
@@ -463,7 +500,9 @@
      * 
      * @param fileName The name of the file to retrieve.
      */
-    /*package*/ final XmlBlock openXmlBlockAsset(String fileName)
+    /*package*/
+    //ADDED COLLABOROID
+    final XmlBlock openXmlBlockAsset(String fileName)
             throws IOException {
         return openXmlBlockAsset(0, fileName);
     }
@@ -617,8 +656,12 @@
         }
     }
 
+    //collaboroid resource sharing
+
     private native final int addAssetPathNative(String path);
 
+
+
      /**
      * Add a set of assets to overlay an already added set of assets.
      *
@@ -809,6 +852,7 @@
             }
             RuntimeException ex = new RuntimeException();
             ex.fillInStackTrace();
+            //Log.d("reviseApp","mRefStacks id : " + id);
             mRefStacks.put(id, ex);
         }
         mNumRefs++;
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/res/Resources.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/Resources.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/res/Resources.java	2017-09-27 02:07:48.947736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/Resources.java	2017-02-15 16:10:58.358573000 +0900
@@ -149,8 +149,13 @@
     private int mLastCachedXmlBlockIndex = -1;
     private final int[] mCachedXmlBlockIds = { 0, 0, 0, 0 };
     private final XmlBlock[] mCachedXmlBlocks = new XmlBlock[4];
+    
+    private int mALastCachedXmlBlockIndex = -1;
+    private final String[] mACachedXmlBlockKeys = { "", "", "", "" };
+    private final XmlBlock[] mACachedXmlBlocks = new XmlBlock[4];
 
     final AssetManager mAssets;
+    //final ABCManager mABC;
     final DisplayMetrics mMetrics = new DisplayMetrics();
 
     private final Configuration mConfiguration = new Configuration();
@@ -262,7 +267,8 @@
      */
     public Resources(AssetManager assets, DisplayMetrics metrics, Configuration config,
             CompatibilityInfo compatInfo) {
-        mAssets = assets;
+        //mABC = ABCManager.getManager();
+    	mAssets = assets;
         mMetrics.setToDefaults();
         if (compatInfo != null) {
             mCompatibilityInfo = compatInfo;
@@ -776,6 +782,22 @@
         }
         return d;
     }
+    //collaboroid
+    public Drawable getDrawable2(String res) throws NotFoundException {
+
+        int id = getABC().getIdFromName(res);
+
+        Log.d("SBJSBJ getDrawable2","getDrawable2 id : " + id);
+        Log.d("SBJSBJ getDrawable2","getDrawable2 name : " + res);
+
+        final Drawable d = getDrawable(id, null);
+        if (d != null && d.canApplyTheme()) {
+            Log.w(TAG, "Drawable " + getResourceName(id) + " has unresolved theme "
+                    + "attributes! Consider using Resources.getDrawable(int, Theme) or "
+                    + "Context.getDrawable(int).", new RuntimeException());
+        }
+        return d;
+    }
 
     /**
      * Return a drawable object associated with a particular resource ID and
@@ -844,6 +866,13 @@
         return getDrawableForDensity(id, density, null);
     }
 
+    //collaboroid
+    /*
+    public Drawable getDrawableForDensity(String id, int density) throws NotFoundException {
+        return getDrawableForDensity(id, density, null);
+    }*/
+
+
     /**
      * Return a drawable object associated with a particular resource ID for the
      * given screen density in DPI and styled for the specified theme.
@@ -858,6 +887,43 @@
      * @throws NotFoundException Throws NotFoundException if the given ID does
      *             not exist.
      */
+    //collaboroid
+    /*
+    public Drawable getDrawableForDensity(String key, int density, @Nullable Theme theme) {
+        TypedValue value;
+        synchronized (mAccessLock) {
+            value = mTmpValue;
+            if (value == null) {
+                value = new TypedValue();
+            } else {
+                mTmpValue = null;
+            }
+            getValueForDensity(id, density, value, true);
+
+            *//*
+             * Pretend the requested density is actually the display density. If
+             * the drawable returned is not the requested density, then force it
+             * to be scaled later by dividing its density by the ratio of
+             * requested density to actual device density. Drawables that have
+             * undefined density or no density don't need to be handled here.
+             *//*
+            if (value.density > 0 && value.density != TypedValue.DENSITY_NONE) {
+                if (value.density == density) {
+                    value.density = mMetrics.densityDpi;
+                } else {
+                    value.density = (value.density * mMetrics.densityDpi) / density;
+                }
+            }
+        }
+
+        final Drawable res = loadDrawable(value, id, theme);
+        synchronized (mAccessLock) {
+            if (mTmpValue == null) {
+                mTmpValue = value;
+            }
+        }
+        return res;
+    }*/
     @Nullable
     public Drawable getDrawableForDensity(@DrawableRes int id, int density, @Nullable Theme theme) {
         TypedValue value;
@@ -1164,6 +1230,12 @@
     public XmlResourceParser getLayout(@LayoutRes int id) throws NotFoundException {
         return loadXmlResourceParser(id, "layout");
     }
+    
+    // ADDED FOR ABCMANAGER
+    //collaboroid
+    public XmlResourceParser getLayout(String key) throws NotFoundException {
+        return loadXmlResourceParser(key, "layout");
+    }
 
     /**
      * Return an XmlResourceParser through which you can read an animation
@@ -1263,6 +1335,10 @@
     public InputStream openRawResource(@RawRes int id, TypedValue value)
             throws NotFoundException {
         getValue(id, value, true);
+        //collaboroid
+        //Log.d("SBJSBJ openRawResource","SBJSBJ openRawResource id: " + id);
+        //Log.d("SBJSBJ openRawResource","SBJSBJ openRawResource hex id: " + Integer.toHexString(id));
+        //getABC().addResource(id);
 
         try {
             return mAssets.openNonAsset(value.assetCookie, value.string.toString(),
@@ -1373,6 +1449,16 @@
         }
         throw new NotFoundException("Resource ID #0x" + Integer.toHexString(id));
     }
+    //collaboroid
+    /*
+    public void getValueForDensity(String key, int density, TypedValue outValue,
+                                   boolean resolveRefs) throws NotFoundException {
+        boolean found = mAssets.getResourceValue(id, density, outValue, resolveRefs);
+        if (found) {
+            return;
+        }
+        throw new NotFoundException("Resource ID #0x" + Integer.toHexString(id));
+    }*/
 
     /**
      * Return the raw data associated with a particular resource ID.
@@ -2293,6 +2379,13 @@
                 + Integer.toHexString(resid));
     }
     
+    /*public String getResourceEntryName2(@AnyRes int resid) throws NotFoundException {
+        String str = mABC.getResourceEntryName(resid);
+        if (str != null) return str;
+        throw new NotFoundException("Unable to find resource ID #0x"
+                + Integer.toHexString(resid));
+    }*/
+    
     /**
      * Parse a series of {@link android.R.styleable#Extra &lt;extra&gt;} tags from
      * an XML file.  You call this when you are at the parent tag of the
@@ -2395,6 +2488,19 @@
     public final AssetManager getAssets() {
         return mAssets;
     }
+    
+    // ADDED FOR COLLABOROID
+    public final ABCManager getABC() {
+    	if(mAssets instanceof ABCManager)
+        	return (ABCManager)mAssets;
+    	else
+    	{
+    		ABCManager m = new ABCManager();
+    		m.addAssetPath("ee");
+    		
+    		return m;
+    	}
+    }
 
     /**
      * Call this to remove all cached loaded layout resources from the
@@ -2493,6 +2599,9 @@
             // Log only framework resources
             if ((id >>> 24) == 0x1) {
                 final String name = getResourceName(id);
+                //collaboroid
+                Log.d("SBJSBJ loadDrawable" ,"SBJSBJ loadDrawable : "+ id);
+                Log.d("SBJSBJ loadDrawable" ,"SBJSBJ loadDrawable : "+ name);
                 if (name != null) {
                     Log.d("PreloadDrawable", name);
                 }
@@ -2773,6 +2882,7 @@
             }
             getValue(id, value, true);
             if (value.type == TypedValue.TYPE_STRING) {
+            	//Log.d(TAG, value.string.toString());
                 return loadXmlResourceParser(value.string.toString(), id,
                         value.assetCookie, type);
             }
@@ -2782,6 +2892,60 @@
         }
     }
     
+    // ADDED FOR ABCMANAGER
+    //collaboroid
+    XmlResourceParser loadXmlResourceParser(String key, String type) throws NotFoundException {
+        //String file = mABC.getResourcePath(key);
+        String file = key;
+        Log.d(TAG, "KEY: " + key + " PATH: " + file);
+        if(file != null)
+        {
+            try {
+                // These may be compiled...
+                synchronized (mACachedXmlBlockKeys) {
+                    // First see if this block is in our cache.
+                    final int num = mACachedXmlBlockKeys.length;
+                    
+                    for (int i=0; i<num; i++) {
+                        if (mACachedXmlBlockKeys[i].equals(key)) {
+                            //System.out.println("**** REUSING XML BLOCK!  id="
+                            //                   + id + ", index=" + i);
+                            return mACachedXmlBlocks[i].newParser();
+                        }
+                    }
+
+                    // Not in the cache, create a new block and put it at
+                    // the next slot in the cache.
+                    XmlBlock block = mAssets.openXmlBlockAsset(file);
+                    if (block != null) {
+                        int pos = mALastCachedXmlBlockIndex+1;
+                        if (pos >= num) pos = 0;
+                        mALastCachedXmlBlockIndex = pos;
+                        XmlBlock oldBlock = mACachedXmlBlocks[pos];
+                        if (oldBlock != null) {
+                            oldBlock.close();
+                        }
+                        mACachedXmlBlockKeys[pos] = key;
+                        mACachedXmlBlocks[pos] = block;
+                        //System.out.println("**** CACHING NEW XML BLOCK!  id="
+                        //                   + id + ", index=" + pos);
+                        return block.newParser();
+                    }
+                }
+            } catch (Exception e) {
+                NotFoundException rnf = new NotFoundException(
+                        "1File " + file + " from xml type " + type + " resource Key: "
+                        + key);
+                rnf.initCause(e);
+                throw rnf;
+            }
+        }
+
+        throw new NotFoundException(
+                "2File " + file + " from xml type " + type + " resource Key: "
+               + key);
+    }
+    
     /*package*/ XmlResourceParser loadXmlResourceParser(String file, int id,
             int assetCookie, String type) throws NotFoundException {
         if (id != 0) {
@@ -2846,7 +3010,8 @@
     }
 
     private Resources() {
-        mAssets = AssetManager.getSystem();
+        //mABC = ABCManager.getManager();
+    	mAssets = AssetManager.getSystem();
         // NOTE: Intentionally leaving this uninitialized (all values set
         // to zero), so that anyone who tries to do something that requires
         // metrics will get a very wrong value.
diff -urN Android_6.0.1_r11/frameworks/base/core/java/android/content/res/TypedArray.java SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/TypedArray.java
--- Android_6.0.1_r11/frameworks/base/core/java/android/content/res/TypedArray.java	2017-09-27 02:07:48.947736110 +0900
+++ SAMD_6.0.1_r11_20170930/frameworks/base/core/java/android/content/res/TypedArray.java	2017-07-12 13:48:45.815966000 +0900
@@ -800,6 +800,13 @@
      * @return Attribute resource identifier, or defValue if not defined.
      * @throws RuntimeException if the TypedArray has already been recycled.
      */
+
+    //reviseApp
+    public int[] getmIndices(){
+        return this.mIndices;
+    }
+    public int[] getmData(){return this.mData;}
+
     @AnyRes
     public int getResourceId(int index, int defValue) {
         if (mRecycled) {
@@ -1169,4 +1176,5 @@
     public String toString() {
         return Arrays.toString(mData);
     }
+
 }
